// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: m_bbox.c,v 1.1 1997/02/03 22:45:10 b1 Exp $";




#include <os.h>

#include "doomdef.h"
#include "m_misc.h"
#include "i_video.h"

#include "g_game.h"
#include "d_main.h"

#ifdef __GNUG__
#pragma implementation "i_system.h"
#endif
#include "i_system.h"




int contrast_change= 0;
int	mb_used = 6;

//Real Time Clock register (get current time in seconds - READ ONLY)
//REG_RTIME = (volatile unsigned int*)(MEM_BASE + 0x90000);
#define REG_RTIME (volatile unsigned*)(MEM_BASE + 0x90000)
//Timer 1 register (~488Hz = ~7x70)
//REG_ATIME = (volatile unsigned int*)(MEM_BASE + 0xC000C);
#define REG_ATIME (volatile unsigned*)(MEM_BASE + 0xC000C)
//Timer 2 register (~100Hz)
//REG_BTIME = (volatile unsigned int*)(MEM_BASE + 0xD000C);
#define REG_BTIME (volatile unsigned*)(MEM_BASE + 0xD000C)



void I_Tactile (int on, int off, int total)
{
  // UNUSED.
  on = off = total = 0;
}

ticcmd_t	emptycmd;
ticcmd_t*	I_BaseTiccmd(void)
{
    return &emptycmd;
}


int  I_GetHeapSize (void)
{
    return mb_used*1024*1024;
}

byte* I_ZoneBase (int*	size)
{
    *size = mb_used*1024*1024;
	printf ("Z_Alloc: Allocating six megs of memory, hold on... \n");
    return (byte *) malloc (*size);
}

//
// I_Init
// Initialize machine state
//
void I_Init (void)
{
	//Initialize timers
	*(volatile byte*)0x900D0014= 0xF;
}


//
// I_GetTime
//
int  I_GetTime (void)
{
	static int			c_time= 0;
    static unsigned int	c_temp= 0xFFFF;
	int  				c_delta= 0;
    
	//return *REG_RTIME;//(*REG_RTIME-basetime);
	
	//Check for overflow
	if (*REG_BTIME<c_temp)
		c_delta= 0;//(*REG_BTIME + (0xFF - c_time)); //fuck, i just can't figure out this overflow
	else
		c_delta= (*REG_BTIME - c_temp);
	
	c_temp = *REG_BTIME;
	c_time+= c_delta;
	//printf("t: %i \n",time);
	return c_time/600;
}

//
// I_StartTic
// Processes events
// Is a bit strange because a PC handles events synchronously, while the Nspire asynchronously
//
void I_StartTic (void)
{
	event_t event;	
	/*
	HOW THIS IS GONNA WORK: PSEUDOCODE
	if (isKeyPressed(KEY_NSPIRE_UP)) {
		event.type= ev_keydown;
		event.data1 = KEY_UPARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_UPARROW;
		D_PostEvent(&event);
	}
	...for every damn key we use...
	...FUCK!
	*/
	
	if (isKeyPressed(KEY_NSPIRE_ENTER)) {
		event.type= ev_keydown;
		event.data1 = KEY_ENTER;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_ENTER;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_CTRL)) {
		event.type= ev_keydown;
		event.data1 = ' ';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = ' ';
		D_PostEvent(&event);
	}

	//HAX HAX HAX
	//Since automap crashes the game
	/*if (isKeyPressed(KEY_NSPIRE_TAB)) {
		event.type= ev_keydown;
		event.data1 = KEY_TAB;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_TAB;
		D_PostEvent(&event);
	}*/
	
	//HAX HAX HAX
	//Kept in until menu is working
	if (isKeyPressed(KEY_NSPIRE_ESC)) {
		//HAX HAX HAX HAX
		I_Quit();
		//HAX HAX HAX HAX
		/*event.type= ev_keydown;
		event.data1 = KEY_ESCAPE;
		D_PostEvent(&event);*/
	} /*else {
		event.type= ev_keyup;
		event.data1 = KEY_ESCAPE;
		D_PostEvent(&event);
	}*/
	if (isKeyPressed(KEY_NSPIRE_PLUS)) {
		if (!contrast_change)
		{
			*(volatile unsigned*)LCD_CNTRST= (*(volatile unsigned*)LCD_CNTRST + 1);
			contrast_change= 1;
		}
	} else if (isKeyPressed(KEY_NSPIRE_MINUS)) {
		if (!contrast_change)
		{
			*(volatile unsigned*)LCD_CNTRST= (*(volatile unsigned*)LCD_CNTRST - 1);
			contrast_change= 1;
		}
	} else {
		contrast_change= 0;
	}
	//HAX HAX HAX
	
	//For movement+shooting, differentiate between Touchpad/Clickpad/Emulator
	#ifdef EMULATOR_CONTROLS
	if (isKeyPressed(KEY_NSPIRE_W)) {
		event.type= ev_keydown;
		event.data1 = KEY_UPARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_UPARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_S)) {
		event.type= ev_keydown;
		event.data1 = KEY_DOWNARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_DOWNARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_A)) {
		event.type= ev_keydown;
		event.data1 = KEY_SLEFTARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_SLEFTARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_D)) {
		event.type= ev_keydown;
		event.data1 = KEY_SRIGHTARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_SRIGHTARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_0)) {
		event.type= ev_keydown;
		event.data1 = KEY_LEFTARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_LEFTARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_PERIOD)) {
		event.type= ev_keydown;
		event.data1 = KEY_RIGHTARROW;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_RIGHTARROW;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_SPACE)) {
		event.type= ev_keydown;
		event.data1 = KEY_RCTRL;
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = KEY_RCTRL;
		D_PostEvent(&event);
	}
	
	if (isKeyPressed(KEY_NSPIRE_1)) {
		event.type= ev_keydown;
		event.data1 = '1';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '1';
		D_PostEvent(&event);
	}
	if (isKeyPressed(KEY_NSPIRE_2)) {
		event.type= ev_keydown;
		event.data1 = '2';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '2';
		D_PostEvent(&event);
	}
	if (isKeyPressed(KEY_NSPIRE_3)) {
		event.type= ev_keydown;
		event.data1 = '3';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '3';
		D_PostEvent(&event);
	}
	if (isKeyPressed(KEY_NSPIRE_4)) {
		event.type= ev_keydown;
		event.data1 = '4';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '4';
		D_PostEvent(&event);
	}
	if (isKeyPressed(KEY_NSPIRE_5)) {
		event.type= ev_keydown;
		event.data1 = '5';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '5';
		D_PostEvent(&event);
	}
	if (isKeyPressed(KEY_NSPIRE_6)) {
		event.type= ev_keydown;
		event.data1 = '6';
		D_PostEvent(&event);
	} else {
		event.type= ev_keyup;
		event.data1 = '6';
		D_PostEvent(&event);
	}
	
	#else
	if (is_touchpad)
	{
		
		if (isKeyPressed(KEY_NSPIRE_8)) {
			event.type= ev_keydown;
			event.data1 = KEY_UPARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_UPARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_5)) {
			event.type= ev_keydown;
			event.data1 = KEY_DOWNARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_DOWNARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_7) || isKeyPressed(KEY_NSPIRE_4)) {
			event.type= ev_keydown;
			event.data1 = KEY_SLEFTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_SLEFTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_9) || isKeyPressed(KEY_NSPIRE_6)) {
			event.type= ev_keydown;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_EXP)) {
			event.type= ev_keydown;
			event.data1 = KEY_LEFTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_LEFTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_SQU)) {
			event.type= ev_keydown;
			event.data1 = KEY_RIGHTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_RIGHTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_EQU) || isKeyPressed(KEY_NSPIRE_TRIG)) {
			event.type= ev_keydown;
			event.data1 = KEY_RCTRL;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_RCTRL;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_A)) {
			event.type= ev_keydown;
			event.data1 = '1';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '1';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_B)) {
			event.type= ev_keydown;
			event.data1 = '2';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '2';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_C)) {
			event.type= ev_keydown;
			event.data1 = '3';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '3';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_H)) {
			event.type= ev_keydown;
			event.data1 = '4';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '4';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_I)) {
			event.type= ev_keydown;
			event.data1 = '5';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '5';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_J)) {
			event.type= ev_keydown;
			event.data1 = '6';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '6';
			D_PostEvent(&event);
		}
		
	} else {
		
		if (isKeyPressed(KEY_NSPIRE_UP)) {
			event.type= ev_keydown;
			event.data1 = KEY_UPARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_UPARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_DOWN)) {
			event.type= ev_keydown;
			event.data1 = KEY_DOWNARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_DOWNARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_LEFT)) {
			event.type= ev_keydown;
			event.data1 = KEY_LEFTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_LEFTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_RIGHT)) {
			event.type= ev_keydown;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_ESC)) {
			event.type= ev_keydown;
			event.data1 = KEY_SLEFTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_SLEFTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_HOME)) {
			event.type= ev_keydown;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_SRIGHTARROW;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_CLICK)) {
			event.type= ev_keydown;
			event.data1 = KEY_RCTRL;
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = KEY_RCTRL;
			D_PostEvent(&event);
		}
		
		if (isKeyPressed(KEY_NSPIRE_1)) {
			event.type= ev_keydown;
			event.data1 = '1';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '1';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_2)) {
			event.type= ev_keydown;
			event.data1 = '2';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '2';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_3)) {
			event.type= ev_keydown;
			event.data1 = '3';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '3';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_4)) {
			event.type= ev_keydown;
			event.data1 = '4';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '4';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_5)) {
			event.type= ev_keydown;
			event.data1 = '5';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '5';
			D_PostEvent(&event);
		}
		if (isKeyPressed(KEY_NSPIRE_6)) {
			event.type= ev_keydown;
			event.data1 = '6';
			D_PostEvent(&event);
		} else {
			event.type= ev_keyup;
			event.data1 = '6';
			D_PostEvent(&event);
		}
	}
	#endif
}

//
// I_Quit
//
void I_Quit (void)
{
    //M_SaveDefaults ();
    I_ShutdownGraphics();
	fuck= true;
	//exit(0);
}

/*void I_BeginRead(void)
{
}

void I_EndRead(void)
{
}
*/

//
// I_GetMainDir
// Processes argv[0], saves current directory path
//
void I_GetMainDir (char* dir)
{
	short i,j= 0;
	i= strlen(dir);
	
	while (i>0) {
	if (j==0 && dir[i]==47)
		j= i;
	i--;
	};
	
	current_dir= malloc(j+2);
	strncpy(current_dir,dir,j+1);
}

byte*	I_AllocLow(int length)
{
    byte*	mem;
        
    mem = (byte *)malloc (length);
    memset (mem,0,length);
    return mem;
}


#if 0
//
// I_ShowDBox
//
void I_ShowDBox(const char* title, const char* msg) {
  char* buffTitle;
  char* buffMsg;

  buffTitle = (char*)malloc(0x200);
  buffMsg = (char*)malloc(0x800);

  ascii2utf16(buffTitle, title, 0x80);
  ascii2utf16(buffMsg, msg, 0x200);
  show_dialog_box2(0, buffTitle, buffMsg);

  free(buffTitle);
  free(buffMsg);
}
#endif

/*//
// toupper
//
void toupper(char *s) {
    for(; *s; s++)
        if(('a' <= *s) && (*s <= 'z'))
            *s = 'A' + (*s - 'a');
}*/

//
// toupper_int
//
int toupper_int(int i) {
	if(('a' <= i) && (i <= 'z'))
		return 'A' + (i - 'a');
	else
		return i;
}

//
// access_ok
//
boolean access_ok(const char *file) {
	struct stat buffer;
	int         status;
	
	//Access the file
	status= stat(file,&buffer);
	
	//Check if the OK value got returned
	if (status==0)
		return true;
	return false;
}

//
// I_Error
//
extern boolean demorecording;

void I_Error (char *error, ...)
{
    va_list	argptr;
	char*	ferror="";

    // Message first.
    va_start (argptr,error);
    printf ("Error: ");
    printf (error,argptr);
    printf ("\n");
    va_end (argptr);

	sprintf(ferror,error,argptr);
	
	//Inform the user something bad had occured
	show_msgbox("FUCK!",error);
	//I_ShowDBox("FUCK!", error);
	
	
    // Shutdown. Here might be other errors.
    if (demorecording)
		G_CheckDemoStatus();
    
	//Exit function here
	//halt(); //better than nothing //NO IT'S NOT
	I_Quit();
}
